#include <at892051.h>
#include <stdlib.h>
#define CLEAR 0x01
#define DATA 0x01
#define CMD  0x00 
#define HYST 0x01   		/*Hysteresys +/-1C          */

#define SELECT 0x00
#define UP 0x01
#define DOWN 0x02
#define ON 1
#define OFF 0
#define LOW 0
#define HIGH 1
#define REWATER_TIME 0x00ff //1hrs  
sbit TMIT=P3^0 ;

sbit SWUP=P1^2;
sbit SWDN=P1^3;
sbit SWSEL=P3^7;
sbit swen=P3^3;     
              	
sbit sel1 =P1^2;		/* Up switch				*/
sbit sel2 =P1^3;		/* Down switch				*/
sbit sel3=P3^7;		        /* Select switch			*/
sbit PUMP =P3^5;		/* Relay enable 0=on			*/
sbit HEATER=P3^4;
sbit ENAD =P1^0;		/* Analog in and timing CAP		*/
//sbit ADREF =P1^1;		/* Reference. Compartitor -		*/
//sbit ADOUT =P3^6;               /* A/D Output pin			*/
sbit RS=P3^0;			  /*  Register Select for CMD/DATA	    */
sbit R_W=P3^1;		 	  /*  Read high, Write low   		    */
sbit ENABLE=P3^2;		  /*  ENABLE pulse (Motorola timing)        */




void lcd_init();
void lcd_4bit_wr(unsigned char ch);
void lcd_wr(bit c_d, unsigned char ch);
void lcd_print(char *ch);
void set_posn(char pos);
void wait(unsigned char tim);
char get_press(void);
void get_rel(void);
signed char look_up(unsigned char time);
unsigned char a_d();
void select(bit s3,bit s2,bit s1);
char  *num_str(signed char num);
bit is_press(); 
void display(char chan);
void setup();
void enable(char *chan);
void get_temp(signed char *(temp)) ;
void set_level(char *setting,char min,char max, char mess);
void output();
void xmit_data();
//void putc(unsigned char ch);

